#pragma once

#include <windows.h>
#include "CameyoPublic.h"

typedef void *PACKAGE_HANDLE;
typedef void *SNAPSHOT_HANDLE;

typedef BOOL (_stdcall *VIRTFS_ENUM_CALLBACK)(
	LPVOID					Data,
	IN  WCHAR*				FileName,
	IN  ULONG				FileFlags,
	LARGE_INTEGER			CreationTime,
	LARGE_INTEGER			LastAccessTime,
	LARGE_INTEGER			LastWriteTime,
	LARGE_INTEGER			ChangeTime,
	LARGE_INTEGER			EndOfFile,
	ULONG					FileAttributes );

typedef BOOL (_stdcall *RUNNINGAPP_ENUM_CALLBACK)(
	IN  LPVOID				Data,
	IN  RUNNING_APP*		RunningApp );

typedef BOOL (_stdcall *DEPLOYEDAPP_ENUM_CALLBACK)(
	IN  LPVOID				Data,
	IN  WCHAR*				AppID );

extern "C" int _stdcall
PackageOpen(
	IN  LPCWSTR				PackageExeFile,
	IN  DWORD				Reserved,
	OUT PACKAGE_HANDLE*		phPkg );

extern "C" int _stdcall
PackageCreate(
	IN  LPCWSTR				AppID,
	IN  LPCWSTR				AppVirtDll,
	IN  LPCWSTR				LoaderExe,
	OUT PACKAGE_HANDLE*		_phPkg );

extern "C" void _stdcall
PackageClose(
	IN  PACKAGE_HANDLE		hPkg );

extern "C" int _stdcall
PackageSave(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				OutFileName );

extern "C" int _stdcall
PackageGetProperty(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				Name,
	OUT LPWSTR				Value,
	IN  DWORD				ValueLen );

extern "C" int _stdcall
PackageSetProperty(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				Name,
	IN  LPCWSTR				Value );

extern "C" int _stdcall
PackageSetIconFile(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				FileName );

extern "C" int _stdcall
PackageBuildStreaming(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				StreamingServerPath,
	IN  LPCWSTR				OutputDir );

extern "C" int _stdcall
VirtFsEnum(
	IN  PACKAGE_HANDLE		hPkg,
	IN  VIRTFS_ENUM_CALLBACK Callback,
	IN  LPVOID				Data );

extern "C" int _stdcall
VirtFsAdd(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				SrcFileName,
	IN  LPCWSTR				DestFileName,
	IN  BOOL				bVariablizeName );

extern "C" int _stdcall
VirtFsAddEx(
	IN  PACKAGE_HANDLE		_hPkg,
	IN  LPCWSTR				SrcFileName,
	IN  LPCWSTR				_DestFileName,
	IN  BOOL				bVariablizeName,
	IN  ULONG				FileFlags );

extern "C" int _stdcall
VirtFsAddEmptyDir(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				DirName,
	IN  BOOL				bVariablizeName );

extern "C" int _stdcall
VirtFsExtract(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				FileName,
	IN  LPCWSTR				TargetDir );

extern "C" int _stdcall
VirtFsDelete(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				FileName );

extern "C" int _stdcall
VirtFsSetFileStreaming(
	IN  PACKAGE_HANDLE		_hPkg,
	IN  LPCWSTR				FileName );

extern "C" int _stdcall
VirtFsGetFileFlags(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				FileName,
	OUT ULONG*				FileFlags );

extern "C" int _stdcall
VirtFsSetFileFlags(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				FileName,
	IN  ULONG				FileFlags );

extern "C" int _stdcall
VirtRegGetWorkKey(
	IN  PACKAGE_HANDLE		hPkg,
	OUT LPWSTR				WorkKey,
	IN  DWORD				WorkKeyLen );

extern "C" int _stdcall
VirtRegGetWorkKeyEx(
	IN  PACKAGE_HANDLE		_hPkg,
	OUT LPWSTR				WorkKey,
	IN  DWORD				WorkKeyLen,
	IN  HANDLE				hAbortEvent );

extern "C" int _stdcall
VirtRegSaveWorkKey(
	IN  PACKAGE_HANDLE		hPkg );

extern "C" int _stdcall
SandboxGetRegistryFlags(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				Path,
	IN  BOOL				bVariablizeName,
	OUT DWORD*				SandboxFlags );

extern "C" int _stdcall
SandboxGetFileFlags(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				Path,
	IN  BOOL				bVariablizeName,
	OUT DWORD*				SandboxFlags );

extern "C" int _stdcall
SandboxSetRegistryFlags(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				Path,
	IN  BOOL				bVariablizeName,
	IN  DWORD				SandboxFlags );

extern "C" int _stdcall
SandboxSetFileFlags(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				Path,
	IN  BOOL				bVariablizeName,
	IN  DWORD				SandboxFlags );

extern "C" int _stdcall
QuickReadIni(
	IN  LPCWSTR				PackageExeFile,
	OUT LPWSTR				IniStr,
	IN  DWORD				IniStrLen );

extern "C" int _stdcall
QuickBuildAppendiceIndex(
	IN  PCHAR					pLastFileBytes,
	IN  DWORD					cbLastFileBytes,
	IN OUT PCHAR				pNewIndex,
	IN OUT DWORD*				pcbNewIndex,
	IN  PCHAR					pSandboxCfg,
	IN  DWORD					cbSandboxCfg,
	IN  PCHAR					pIniBuf,
	IN  DWORD					cbIniBuf );

extern "C" int _stdcall
QuickBuildAppendiceIndexFile(
	IN  PCHAR					pLastFileBytes,
	IN  DWORD					cbLastFileBytes,
	IN OUT PCHAR				pNewIndex,
	IN OUT DWORD*				pcbNewIndex,
	IN  LPCWSTR					SandboxCfgFile,
	IN  LPCWSTR					IniFile );

extern "C" int _stdcall
ExtractAppendiceIndex(
	IN  LPCWSTR					FileName,
	IN  LPCWSTR					OutputFile );

extern "C" int _stdcall
RunningAppEnum(
	IN  RUNNINGAPP_ENUM_CALLBACK Callback,
	IN  LPVOID					Data );

extern "C" int _stdcall
RunningAppEnumKeepAlive(
	IN OUT LPVOID*				Context,
	IN  RUNNINGAPP_ENUM_CALLBACK Callback,
	IN  LPVOID					Data );

extern "C" int _stdcall
RunningAppEnumKeepAliveFree(
	IN OUT LPVOID				Context );

extern "C" int _stdcall
DeployedAppEnum(
	IN  DEPLOYEDAPP_ENUM_CALLBACK Callback,
	IN  LPVOID					Data );

extern "C" int _stdcall
DeployedAppGetDir(
	IN  LPCWSTR					AppID,
	OUT LPWSTR					BaseDirName,
	IN  DWORD					BaseDirNameLen );
